<?php
class RSS_feed
{
  var $flag;
  var $state;
  var $level;
  var $output;
  var $showdesc;
  var $showimage;
  var $URL;
  var $psr;
  var $contents;
  var $rss_version;
  var $limit;
  var $channel;
  var $image;
  var $item;
  var $channelclosed;
  function RSS_feed()
  {
    $this->output = "";
    $this->channel = array();
    $this->image = array();
    $this->item = array();
    $this->flag = false;
    $this->state = 0;
    $this->level = 0;
    $this->showdesc = false;
    $this->showimage = false;
    $this->channelclosed = false;
    $this->version = 9;   // set 0.9x as default;
    $this->limit = 0;   // use 0 as default == all
  }
  function Show_Description($tf)
  {
    if (!$tf === false)
    {
      $this->showdesc = true;
    } else {
      $this->showdesc = false;
    }
  }
  function Show_Image($tf)
  {
    if (!$tf === false)
    {
      $this->showimage = true;
    } else {
      $this->showimage = false;
    }
  }
  function Set_URL($url)
  {
    $this->URL = $url;
    $this->_load_file();
    $this->_get_rss_version();
  }
  function Set_Limit($cnt)
  {
    $i = intval($cnt);
    if ($i > 0) $this->limit = $i;
  }
  function Get_Results()
  {
    $c = $this->contents;
    $this->psr = xml_parser_create();
    xml_set_object($this->psr, $this);
    xml_parser_set_option($this->psr,XML_OPTION_CASE_FOLDING,1);
    switch ($this->version)
    {
      case 9:
      case 2;
        xml_set_element_handler($this->psr, '_handle_open_element', '_handle_close_element');
        break;
      case 1:
        xml_set_element_handler($this->psr, '_rdf_handle_open_element', '_handle_close_element');
        break;
    }
    xml_set_character_data_handler($this->psr, "_handle_character_data");
    if (!xml_parse ($this->psr, $c))
    {
      $ln =  xml_get_current_line_number($this->psr);
      $msg =  xml_error_string(xml_get_error_code($this->psr));
      return "An XML error occurred on line $ln: $msg";
    }
    xml_parser_free($this->psr);
    $this->contents = "";
    $this->output .= "</ul>";
    return $this->output;
  }
  function _handle_open_element (&$p, &$element, &$attributes)
  {
    $element = strtolower($element);
    switch($element)
    {
      case 'rss':
        $this->level = 0;
        $this->state = 0;
        break;
      case 'channel':
        $this->flag = true;
        $this->level = 1;
        $this->state = 1;
        break;
      case 'item':
        $this->level = 3;
        $this->state = 3;
        break;
      case 'pubdate':
      case 'managingeditor':
      case 'webmaster':
      case 'width':
      case 'height':
      case 'language':
        $this->state = 99;
        break;
      case 'image':
        $this->level = 2;
        break;
      case 'title':
        $this->state = 4;
        break;
      case 'link':
        $this->state = 5;
        break;
      case 'description':
        $this->state = 6;
        break;
      case 'url':
        $this->state = 7;
        break;
      default:
        $this->state = 99;
        break;
    }
  }
  function _rdf_handle_open_element(&$p, &$element, &$attributes)
  {
    $element = strtolower($element);
    switch($element)
    {
      case "rdf:rdf":
        $this->level = 0;
        $this->state = 0;
        break;
      case "channel":
        $this->flag = true;
        $this->level = 1;
        $this->state = 1;
        break;
      case "image":
        $this->level = 2;
        break;
      case "items":
        $this->state = 99;
        break;
      case "item":
        $this->level = 3;
        $this->state = 3;
        break;
      case "title":
        $this->state = 4;
        break;
      case "link":
        $this->state = 5;
        break;
      case "description":
        $this->state = 6;
        break;
      case "url":
        $this->state = 7;
        break;
      case "rdf:seq":
      case "rdf:li":
      default:
        $this->state = 99;
        break;
    }
  }
  function _handle_character_data(&$p, &$cdata)
  {
    $s = trim($cdata);
    if (strlen($s)) {
      switch ($this->state)
      {
        case 4:
          switch ($this->level)
          {
            case 1:
              $this->channel["title"] .= $cdata;
              break;
            case 2;
              $this->image["title"] .= $cdata;
              break;
            case 3:
              $this->item["title"] .= $cdata;
              break;
          }
          break;
        case 5:
          switch ($this->level)
          {
            case 1:
              $this->channel["link"] .= $cdata;
              break;
            case 2:
              $this->image["link"] .= $cdata;
              break;
            case 3:
              $this->item["link"] .= $cdata;
              break;
          }
          break;
        case 6:
          if ($this->showdesc)
          {
            switch ($this->level)
            {
              case 1:
                $this->channel["desc"] .= $cdata;
                break;
              case 3:
                $this->item["desc"] .= $cdata;
                break;
            }
          }
          break;
        case 7:
          if ($this->showimage)
          {
            switch ($this->level)
            {
              case 2:
                $this->image["url"] .= $cdata;
                break;
            }
          }
          break;
      }
    }
  }
  function _handle_close_element(&$p, &$element)
  {
    $element = strtolower($element);
    static $cnt;
    switch ($element)
    {
      case 'channel':
        if ($this->showimage && $this->image["link"])
        {
          $outbuffer .= '<a href="' . $this->image["link"] . '" ><img src="'
          . $this->image["url"] . '" border=0 alt="' . $this->image["title"] . '"></a><br>';
        }
        $outbuffer .= '<a href="' . $this->channel["link"] . '" target="_blank">'
          . $this->channel["title"] . '</a><br>';
        if ($this->showdesc)
          $outbuffer .= $this->channel["desc"];
        $outbuffer .= $this->output;
        $this->output = $outbuffer;
        $this->channel["link"] = "";
        $this->channel["title"] = "";
        $this->channel["desc"] = "";
        $this->channelclosed = true;
        break;
      case 'image':
        if ($this->channelclosed)
        {
          if ($this->showimage && $this->image["link"])
          {
            $outbuffer .= '<a href="' . $this->image["link"] . '" ><img src="'
            . $this->image["url"] . '" border=0 alt="' . $this->image["title"] . '"></a><br>';
            $this->output = $outbuffer . $this->output;
          }
        }
        break;
      case 'item':
        if ($this->flag)
        {
          $this->output .= "<ul>";
          $this->flag = false;
          $cnt = 0;
        }
        if ($this->limit > $cnt || !$this->limit)
        {
          $this->output .= '<li><b><a href="' . $this->item["link"] . '" >'
            . $this->item["title"] . '</a></b><br>';
          if ($this->showdesc)
            $this->output .= $this->item["desc"];
          if ($this->limit > 0) $cnt++;
        }
        $this->item["link"] = "";
        $this->item["title"] = "";
        $this->item["desc"] = "";
        break;
      default:
        break;
    }
  }
  function _load_file()
  {
    $data = @file($this->URL) or die ("Could not open a feed called: " . $this->URL);
    $this->contents = implode('',$data);
  }
  function _get_rss_version()
  {
    if (strpos($this->contents,'version="0.9'))  $this->rss_version = 9;
    elseif (strpos($this->contents,"rdf:")) $this->rss_version = 1;
    elseif (strpos($this->contents,'version="2.0"')) $this->rss_version = 2;
  }
}
?>